Loading...
Searching...
No Matches
QGpgME::Protocol Class Referenceabstract

`#include <protocol.h>`

## Public Member Functions

virtual QString | name () const =0
virtual QString | displayName () const =0
virtual KeyListJob * | keyListJob (bool remote=false, bool includeSigs=false, bool validate=false) const =0
virtual ListAllKeysJob * | listAllKeysJob (bool includeSigs=false, bool validate=false) const =0
virtual EncryptJob * | encryptJob (bool armor=false, bool textmode=false) const =0
virtual DecryptJob * | decryptJob () const =0
virtual SignJob * | signJob (bool armor=false, bool textMode=false) const =0
virtual VerifyDetachedJob * | verifyDetachedJob (bool textmode=false) const =0
virtual VerifyOpaqueJob * | verifyOpaqueJob (bool textmode=false) const =0
virtual KeyGenerationJob * | keyGenerationJob () const =0
virtual ImportJob * | importJob () const =0
virtual ImportFromKeyserverJob * | importFromKeyserverJob () const =0
virtual ExportJob * | publicKeyExportJob (bool armor=false) const =0
virtual ExportJob * | secretKeyExportJob (bool armor=false, const QString &=QString()) const =0
virtual DownloadJob * | downloadJob (bool armor=false) const =0
virtual DeleteJob * | deleteJob () const =0
virtual SignEncryptJob * | signEncryptJob (bool armor=false, bool textMode=false) const =0
virtual DecryptVerifyJob * | decryptVerifyJob (bool textmode=false) const =0
virtual RefreshKeysJob * | refreshKeysJob () const =0
virtual ChangeExpiryJob * | changeExpiryJob () const =0
virtual SignKeyJob * | signKeyJob () const =0
virtual ChangePasswdJob * | changePasswdJob () const =0
virtual ChangeOwnerTrustJob * | changeOwnerTrustJob () const =0
virtual AddUserIDJob * | addUserIDJob () const =0
virtual SpecialJob * | specialJob (const char *type, const QMap< QString, QVariant > &args) const =0
virtual KeyListJob * | locateKeysJob () const =0
virtual KeyForMailboxJob * | keyForMailboxJob () const =0
virtual WKSPublishJob * | wksPublishJob () const =0
virtual TofuPolicyJob * | tofuPolicyJob () const =0
virtual QuickJob * | quickJob () const =0
virtual WKDLookupJob * | wkdLookupJob () const =0
virtual ExportJob * | secretSubkeyExportJob (bool armor=false) const =0
virtual AddExistingSubkeyJob * | addExistingSubkeyJob () const =0
virtual ReceiveKeysJob * | receiveKeysJob () const =0
virtual RevokeKeyJob * | revokeKeyJob () const =0
virtual SetPrimaryUserIDJob * | setPrimaryUserIDJob () const =0
virtual EncryptArchiveJob * | encryptArchiveJob (bool armor=false) const =0
virtual SignArchiveJob * | signArchiveJob (bool armor=false) const =0
virtual SignEncryptArchiveJob * | signEncryptArchiveJob (bool armor=false) const =0
virtual DecryptVerifyArchiveJob * | decryptVerifyArchiveJob () const =0
virtual WKDRefreshJob * | wkdRefreshJob () const =0
virtual ADQueryJob * | adQueryJob () const =0

## Detailed Description

The main entry point for QGpgME Comes in OpenPGP and SMIME(CMS) flavors.

Use the proctocol class to obtain an instance of a job. Jobs provide async API for GnuPG that can be connected to signals / slots.

A job is usually started with start() and emits a result signal. The parameters of the result signal depend on the job but the last two are always a QString for the auditlog and an GpgME::Error for an eventual error.

In case async API is used and the result signal is emitted a job schedules its own deletion.

Most jobs also provide a synchronous call exec in which case you have to explicitly delete the job if you don't need it anymore.

// Async example:
KeyListJob *job = openpgp()->keyListJob();
connect(job, &KeyListJob::result, job, [this, job](KeyListResult, std::vector<Key> keys, QString, Error)
{
// keys and resuls can now be used.
});
job->start({QStringLiteral("alfa@example.net")}, false);
QGpgME::KeyListJob
An abstract base class for asynchronous key listers.
Definition keylistjob.h:72
QGpgME::KeyListJob::start
virtual GpgME::Error start(const QStringList &patterns, bool secretOnly=false)=0
// Sync eaxmple:
KeyListJob *job = openpgp()->keyListJob(false, false, false);
std::vector<GpgME::Key> keys;
GpgME::KeyListResult result = job->exec(QStringList() <<
QStringLiteral("alfa@example.net"),
false, keys);
delete job;

## Member Function Documentation

## keyForMailboxJob()

virtual KeyForMailboxJob * QGpgME::Protocol::keyForMailboxJob | ( |  | ) | const

pure virtual

Find the best key to use for a mailbox.

## locateKeysJob()

virtual KeyListJob * QGpgME::Protocol::locateKeysJob | ( |  | ) | const

pure virtual

A key locate job.

This tries to find a key in local and remote sources, if the key was remote it is imported by GnuPG. Same as KeyListJob but intended to be used to locate keys automatically. This ends up calling –locate-keys.

Only available for OpenPGP

Results are validated. As if keyListJob was called with both includeSigs and validate options.

## quickJob()

virtual QuickJob * QGpgME::Protocol::quickJob | ( |  | ) | const

pure virtual

A Job for the quick commands

## refreshKeysJob()

virtual RefreshKeysJob * QGpgME::Protocol::refreshKeysJob | ( |  | ) | const

pure virtual

For S/MIME keys this job performs a full validation check of the keys with updated CRLs. For OpenPGP keys, use receiveKeysJob.

## setPrimaryUserIDJob()

virtual SetPrimaryUserIDJob * QGpgME::Protocol::setPrimaryUserIDJob | ( |  | ) | const

pure virtual

Returns a job for flagging a user ID as the primary user ID of an OpenPGP key.

## tofuPolicyJob()

virtual TofuPolicyJob * QGpgME::Protocol::tofuPolicyJob | ( |  | ) | const

pure virtual

A Job to set tofu policy

## wkdLookupJob()

virtual WKDLookupJob * QGpgME::Protocol::wkdLookupJob | ( |  | ) | const

pure virtual

This job looks up a key via WKD without importing it.

## wksPublishJob()

virtual WKSPublishJob * QGpgME::Protocol::wksPublishJob | ( |  | ) | const

pure virtual

A Job for interacting with gnupg's wks tools.

The documentation for this class was generated from the following file:

- protocol.h